"use strict";
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var chai_1 = require("chai");
var backend_1 = require("../backend");
var testconfig_1 = require("./testconfig");
var testsuite_1 = require("rev-models/lib/backends/testsuite");
describe('MongoDBBackend', function () {
    var backend;
    describe('Connecting to MongoDB', function () {
        afterEach(function () {
            backend.disconnect();
        });
        it('can connect to existing mongodb server', function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        backend = new backend_1.MongoDBBackend(testconfig_1.testConfig);
                        return [4 /*yield*/, backend.connect()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('throws an error when connection fails', function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        backend = new backend_1.MongoDBBackend({
                            url: 'mongodb://localhost:12345',
                            dbName: 'RevJS'
                        });
                        return [4 /*yield*/, backend.connect()
                                .then(function () {
                                throw new Error('expected to throw');
                            })
                                .catch(function (e) {
                                chai_1.expect(e.message).to.contain('failed to connect to server');
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
describe('MongoDBBackend - RevJS Backend Tests', function () {
    var config = {};
    var backend;
    before(function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    backend = new backend_1.MongoDBBackend(testconfig_1.testConfig);
                    return [4 /*yield*/, backend.connect()];
                case 1:
                    _a.sent();
                    config.backend = backend;
                    return [2 /*return*/];
            }
        });
    }); });
    testsuite_1.standardBackendTests('MongoDBBackend', config);
    after(function () {
        backend.disconnect();
    });
});
//# sourceMappingURL=backend.tests.js.map